<?php
/*
Plugin Name: Domain Of The Ancients
Plugin URI: https://blog.tremlas.com/wordpress-plugins/domain-of-the-ancients-plugin-details/
Description: Adds a shortcode that inserts the Domain Of The Ancients game
Version: 3.170.0
Author: David Vines
Author URI: http://tremlas.com
License:  Creative Commons License
*/
/* © Copyright 2021 David Vines

   Creative Commons License

   This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
*/

include_once 'common.php';

/**
 * Shortcode to add the version of the plugin
 */
function djv_domainOfTheAncients_domainOfTheAncientsVersion_shortcode() {
	return 'Domain Of The Ancients Version 3.170.0';
}
add_shortcode( 'domainOfTheAncientsVersion', 'djv_domainOfTheAncients_domainOfTheAncientsVersion_shortcode' );

/**
 * Add the "Domain Of The Ancients" game. Only one per page is supported.
 */

// Now for a shortcode that can be used to get links and/or tables for the characters
function djv_domainOfTheAncients_shortcode( $attr, $content = null ) {
	$plugin_url = plugin_dir_url(__FILE__);
	wp_enqueue_script('djv_domainOfTheAncients_rot',    $plugin_url.'js/rot/rot.min.js', array(), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_util',   $plugin_url.'js/domainOfTheAncients/util.js', array(), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_tech',   $plugin_url.'js/domainOfTheAncients/tech.js', array(), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_map',    $plugin_url.'js/domainOfTheAncients/map.js', array('djv_domainOfTheAncients_rot'), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_player', $plugin_url.'js/domainOfTheAncients/player.js', array('djv_domainOfTheAncients_tech'), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_order',  $plugin_url.'js/domainOfTheAncients/order.js', array('djv_domainOfTheAncients_tech', 'djv_domainOfTheAncients_player'), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_playerorders', $plugin_url.'js/domainOfTheAncients/playerorders.js', array('djv_domainOfTheAncients_util', 'djv_domainOfTheAncients_order', 'djv_domainOfTheAncients_tech'), '3.170.0' );
	wp_enqueue_script('djv_domainOfTheAncients_game',   $plugin_url.'js/domainOfTheAncients/game.js', array('djv_domainOfTheAncients_util', 'djv_domainOfTheAncients_tech', 'djv_domainOfTheAncients_map', 'djv_domainOfTheAncients_player', 'djv_domainOfTheAncients_order', 'djv_domainOfTheAncients_playerorders', 'djv_domainOfTheAncients_rot'), '3.170.0' );

	wp_enqueue_style('djv_domainOfTheAncientsStyle', $plugin_url.'css/domainOfTheAncients.css', array(), '3.170.0' );

	$file = plugin_dir_path(__FILE__);
	$filecontent = file_get_contents($file.'/html/domainOfTheAncients.html');

	// Remove unnecessary paragraph wrapping from any content to be embedded into the html
	// And then embed it into the html
	if (! empty( $content ) ) {
		$patterns = array('/^<\/p>/i', '/<p>$/i');
		$content = preg_replace($patterns, '', $content);
		$filecontent = str_replace('@@@ADDEDINFO@@@', $content, $filecontent );
	} else {
		// Remove the @@@ADDEDINFO@@@ embed
		$filecontent = str_replace('@@@ADDEDINFO@@@', '', $filecontent );
	}

	return $filecontent;
}

add_shortcode( 'domainOfTheAncients', 'djv_domainOfTheAncients_shortcode' );

/* --------------------- Functions for updating plugins ------------------------------ */
function djv_domainOfTheAncients_pre_set_site_transient_update_plugins( $transient ) {
 $id = 'domainOfTheAncients/domainOfTheAncients.php';
 $name = 'Domain Of The Ancients';
 $slug = 'domainOfTheAncients';
 return djv_plugin_pre_set_site_transient( $transient, $id, $name, $slug, '3.170.0' );
}
add_filter( 'pre_set_site_transient_update_plugins', 'djv_domainOfTheAncients_pre_set_site_transient_update_plugins' );

function djv_domainOfTheAncients_plugin_info( $result, $action, $args ) {
	$name = 'Domain Of The Ancients';
	$slug = 'domainOfTheAncients';
	if ( 'plugin_information' !== $action ) {
		return $result;
	}
	if ( $slug !== $args->slug) {
		return $result;
	}
	return djv_plugin_get_remote_update_info( $name, $slug );
}
add_filter( 'plugins_api', 'djv_domainOfTheAncients_plugin_info', 10, 3 );

?>