/*!
 * © 2022 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */
/* globals stylenames, ALLTECHS */
/* exported Player */
class Player {
	constructor(index,techIndex) {
		let techselect = document.getElementById("favouredTech");
		this._index = index;
		this._techIndex = techIndex;
		this._tech = techselect.options[techIndex].text;
		this._carriedProduction = 0;
		this._research = Array.from(ALLTECHS, _tech => { return 0; });
		this._production = 400;
	}
	get stylename() {
		return stylenames[this._index];
	}
	get production() {
		return this._production;
	}
	set production(p) {
		this._production = p;
	}
	get carriedProduction() {
		return this._carriedProduction;
	}
	set carriedProduction(cp) {
		this._carriedProduction = cp;
	}
	get techIndex() {
		return this._techIndex;
	}
	get tech() {
		return this._tech;
	}
	researchLevel(tech) {
		return ALLTECHS[tech.index].level(this._research[tech.index]);
	}
	addResearch(tech,points) {
		let oldLevel = this.researchLevel(tech);
		this._research[tech.index] += parseInt(points);
		let newLevel = this.researchLevel(tech);
		return newLevel > oldLevel;
	}
	forEachTech(f) {
		let self = this;
		ALLTECHS.forEach(function(tech,index) {
			f(tech,self._research[index]);
		});
	}
	stringify() {
		let data = {carried: this._carriedProduction, research: this._research, production: this._production };
		return JSON.stringify(data);
	}
	setFromJSON(json) {
		let data = JSON.parse(json);
		this._production = data.production;
		this._carriedProduction = data.carried;
		this._research = data.research;
	}
}