/*!
 * © 2022 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */
/* exported Tech, TECHS, ALLTECHS */
var ALLTECHS = [];
class Tech {
	constructor(domprefix,option,levels) {
		this._domprefix = domprefix;
		this._option = option;
		this._index = ALLTECHS.length;
		this._levels = [...levels];
		ALLTECHS.push(this);
	}
	level(points) {
		let l = 1; // Default level is 1
		for(let i=0; i<this._levels.length; i++)
		{
			if (points >= this._levels[i]) {
				l = i+2; // Zeroth entry is the level needed for TL2
			}
		}
		return l;
	}
	moreResearchAvailable(points) {
		return points < this._levels[this._levels-1];
	}
	get domPrefix() { return this._domprefix; }
	get option() { return this._option; }
	get index() { return this._index; }
}
var TECHS = {
	powerPlant:        new Tech("powerPlant",       "Power Plant",        [270,1520,4000,6250,10000,19900]),
	jumpDrive:         new Tech("jumpDrive",        "Jump Drive",         [240,1240,2700,4750,7000,11000,15000]),
	maneuverDrive:     new Tech("maneuverDrive",    "Maneuver Drive",     [240,1240,2700,4750,7000,11000,15000]),
	communications:    new Tech("communications",   "Communications",     [240,800,1700,3650,6450,10000,15500]),
	shipSize:          new Tech("shipSize",         "Ship Size",          [240,800,1800,4000,8000,13700,20000,30000]),
	planetaryDefences: new Tech("planetaryDefence", "Planetary Defences", [240,960,2150,5000,10000,16000,20000]),
	weaponary:         new Tech("weaponary",        "Ship Weaponary",     [240,960,2150,5000,7000,10000,12500,16000,20000,25000]),
	computers:         new Tech("computers",        "Computers",          [240,960,2150,4000,6400,9500,15000]),
	shipDefences:      new Tech("shipDefences",     "Ship Defences",      [240,1600,2500,4000,6000,8000,12000]),
	archaeology:       new Tech("archaeology",      "Archaeology",        [240,1600,4000,7500,10000])
};
